package model {
	import control.xml.CSSParser;

	import flash.text.StyleSheet;

	import events.SphereEvent;

	import flash.system.LoaderContext;
	import flash.system.ApplicationDomain;

	import br.com.stimuli.loading.BulkProgressEvent;
	import br.com.stimuli.loading.BulkLoader;
	import control.xml.DataParser;

	import com.dtas.events.SystemEvent;

	import control.xml.ConfigParser;
	import flash.events.EventDispatcher;


	/**
	 * @author sbuchbin
	 */
	public class DataModel {
		
		public static var CONFIG_FILE : String;
		public static var DATA_FILE : String;
		public static var CSS_FILE : String;
		
		
		public var appdata : Object;
		public var loader : BulkLoader;
		
		public var stylesheet : StyleSheet;
	
		public var dispatcher : EventDispatcher;
		
		private var _appDomain: ApplicationDomain;
		
		private static var _inst : DataModel;
		
		public static function getInstance():DataModel{
			if(_inst == null)
				_inst = new DataModel();
			return _inst; 
		}
		
		public function DataModel() {
			
			appdata = new Object();
			
			dispatcher = new EventDispatcher();
			dispatcher.addEventListener(SystemEvent.CONFIG_PARSE_COMPLETE, onConfigComplete);
			dispatcher.addEventListener(SystemEvent.CSS_PARSE_COMPLETE, onCSSComplete);
			dispatcher.addEventListener(SystemEvent.DATA_PARSE_COMPLETE, onAppDataComplete);
			
			loader = new BulkLoader("image-loader");
			loader.logLevel = BulkLoader.LOG_SILENT;
		//	loader.logLevel = BulkLoader.LOG_INFO;
			loader.addEventListener(BulkLoader.COMPLETE, onAllImagesLoaded);
			loader.addEventListener(BulkLoader.PROGRESS, onBulkProgress);
			


			init();
			
		
			

	
		}
		
		private function init():void{
			new ConfigParser(CONFIG_FILE);
		}
		
		
		private function onBulkProgress ( e : BulkProgressEvent ) : void
		{
			var percent : Number = Math.round(e.percentLoaded * 100);
		
			dispatcher.dispatchEvent(new SystemEvent(SystemEvent.LOAD_PROGRESS, {percent: percent}));
			if(percent == 100)
			{
				loader.removeEventListener(BulkLoader.PROGRESS, onBulkProgress);
			}
			 
		}
		
		private function onAllImagesLoaded ( e : BulkProgressEvent ) : void
		{
	
			// remove the event listener
			loader.removeEventListener(BulkLoader.COMPLETE, onAllImagesLoaded);

			DataModel.getInstance().dispatcher.dispatchEvent(new SphereEvent(SphereEvent.INTRO_START));
			//DataModel.getInstance().dispatcher.dispatchEvent(new SphereEvent(SphereEvent.INTRO_COMPLETE));
	
		}
		
		
		private function onConfigComplete(evt:SystemEvent):void{
			dispatcher.removeEventListener(SystemEvent.CONFIG_PARSE_COMPLETE, onConfigComplete);
			
		
			new CSSParser(CSS_FILE);
		}
		
		private function onCSSComplete(evt:SystemEvent):void{
			dispatcher.removeEventListener(SystemEvent.CSS_PARSE_COMPLETE, onCSSComplete);
			
			new DataParser(DATA_FILE);
		}
		
		private function onAppDataComplete(evt:SystemEvent):void{
			
			dispatcher.removeEventListener(SystemEvent.DATA_PARSE_COMPLETE, onAppDataComplete);
			
			var imageAry : Array = getDataArray("preload");
			
			_appDomain = new ApplicationDomain(ApplicationDomain.currentDomain);
			
			var context : LoaderContext = new LoaderContext();
			context.applicationDomain = _appDomain;
			
			for(var i : uint = 0; i < imageAry.length; i++)
			{
				var node : Object = imageAry[i];
				
				var src : String = node.src;
				var id  : String = node.id;
				
				loader.add(src, {id:id,maxTries:6, priority:imageAry.length-i,context:context});
			}
			
			loader.start();
			
			

			
			
			//
			
		}
		
		public function getDataString(id:String):String{
			return appdata[id] as String;
		}
		public function getDataArray(id:String):Array{
			return appdata[id] as Array;	
		}
		
		
		
		public function getSectionById(id:String) : SectionInfo{
			
			var sections : Array = appdata["sections"];
			var info : SectionInfo;
			for(var i : uint = 0; i < sections.length; i++)
			{
				var section : SectionInfo = sections[i] as SectionInfo;
				
				if(section.id == id)
				{
					info = section;
					break;
				}
	
			}
			return info;
			
		}
	}
}
